/* -*- C++ -*-
 *
 * This file is a part of LEMON, a generic C++ optimization library
 *
 * Copyright (C) 2003-2006
 * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
 * (Egervary Research Group on Combinatorial Optimization, EGRES).
 *
 * Permission to use, modify and distribute this software is granted
 * provided that this copyright notice appears in all copies. For
 * precise terms see the accompanying LICENSE file.
 *
 * This software is provided "AS IS" with no warranty of any kind,
 * express or implied, and with no claim as to its suitability for any
 * purpose.
 *
 */

#ifndef MAP_WINDOW
#define MAP_WINDOW

#include <gtkmm/window.h>
#include <gtkmm/liststore.h>
#include <gtkmm/treeview.h>
#include <gtkmm/scrolledwindow.h>
#include "mapstorage.h"

class MapWindow : public Gtk::Window
{
  struct MapModelColumns : public Gtk::TreeModel::ColumnRecord
  {
    MapModelColumns()
    {
      add(colName);
      add(colValue);
      add(colType);
    }
    Gtk::TreeModelColumn<Glib::ustring> colName;
    Gtk::TreeModelColumn<MapStorage::value> colValue;
    Gtk::TreeModelColumn<MapStorage::type> colType;
  };
  private:
    MapModelColumns mapColumns;
    Glib::RefPtr<Gtk::ListStore> refMapStore;
    Gtk::TreeView twMap;
    Gtk::ScrolledWindow swMap;
  public:
    MapWindow();
    ~MapWindow();
};

#endif
